﻿# -*- coding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2007 Naritas Ltda. (http://www.naritasltda.com) All Rights Reserved.
#
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License 
# Version 3 as published by the Free Software Foundation 
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import netsvc
import ir
from mx import DateTime
import time
import oplog
from report import report_sxw
from osv import fields, osv, orm
import locale
#

class oplog_carta_apertura_do(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_apertura_do, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.apertura','oplog.do','addons/oplog/cartas/apertura_do.rml',parser=oplog_carta_apertura_do, header=False)

class oplog_carta_motonave(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_motonave, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.motonave','oplog.do','addons/oplog/cartas/do_motonave.rml',parser=oplog_carta_motonave, header=False)

class oplog_reporte_final(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_reporte_final, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.final','oplog.do','addons/oplog/cartas/reporte_final.rml',parser=oplog_reporte_final, header=False)

class oplog_carta_coloading(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_coloading, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.coloading','oplog.do','addons/oplog/cartas/carta_coloading.rml',parser=oplog_carta_coloading, header=False)

class oplog_carta_radmanual(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_radmanual, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.radmanual','oplog.dian','addons/oplog/cartas/rad_manual.rml',parser=oplog_carta_radmanual, header=False)

class oplog_manifiesto_carga(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_manifiesto_carga, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.manifiesto','oplog.dian','addons/oplog/cartas/manifiesto_carga.rml',parser=oplog_manifiesto_carga, header=False)

class oplog_carta_vaciado(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_vaciado, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.vaciado','oplog.vaciado','addons/oplog/cartas/vaciado_puerto.rml',parser=oplog_carta_vaciado, header=False)

class oplog_carta_vaciado2(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_vaciado2, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.vaciado2','oplog.vaciado','addons/oplog/cartas/vaciado_puerto2.rml',parser=oplog_carta_vaciado2, header=False)

class oplog_informe_inconsistencia(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_informe_inconsistencia, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.pendiente','oplog.pendiente','addons/oplog/cartas/informe_inconsistencia.rml',parser=oplog_informe_inconsistencia, header=False)

class oplog_carta_naviera(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_naviera, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.naviero','oplog.naviero','addons/oplog/cartas/carta_naviera.rml',parser=oplog_carta_naviera, header=False)

class oplog_solicitud_anticipo(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_solicitud_anticipo, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time,
			'formatNumber': self.formatNumber,
		})

	def formatNumber(self, val):
		return locale.format('%d', val, True)
		
report_sxw.report_sxw('report.oplog.do.anticipo','oplog.anticipo','addons/oplog/cartas/solicitud_anticipo.rml',parser=oplog_solicitud_anticipo, header=False)

class oplog_srvc_factr(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_srvc_factr, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.factpto','oplog.radpuerto','addons/oplog/cartas/solicitud_facturacion.rml',parser=oplog_srvc_factr, header=False)

class oplog_radicado_puerto(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_radicado_puerto, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.radicado','oplog.radpuerto','addons/oplog/cartas/radicado_puerto.rml',parser=oplog_radicado_puerto, header=False)

class oplog_listblh_blm(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_listblh_blm, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.blmaster.listblh','oplog.blmaster','addons/oplog/cartas/associate_blm_blh.rml',parser=oplog_listblh_blm, header=False)

class oplog_aci_blh(report_sxw.rml_parse):
	aci = {}
	def __init__(self, cr, uid, name, context):
		super(oplog_aci_blh, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
			'get_distinct_aci': self.get_distinct_aci,
			'get_blh_by_aci': self.get_blh_by_aci,
		})
	def get_distinct_aci(self, aci_blh):
		self.aci = {}
		for line in aci_blh:
			if line.aci_name in self.aci:
				self.aci[line.aci_name].append([line.name, line.do_name, line.referencia, line.motonave, line.port, line.consig_blm, line.liberado])
			else:
				self.aci[line.aci_name] = [[line.name, line.do_name, line.referencia, line.motonave, line.port, line.consig_blm, line.liberado]]

		return self.aci.keys()
	def get_blh_by_aci(self, aci_name):
		if aci_name in self.aci:
			return self.aci[aci_name]
		else:
			return None

report_sxw.report_sxw('report.oplog.aci.blh','oplog.aci.blh','addons/oplog/cartas/aci_blh.rml',parser=oplog_aci_blh, header=False)

class oplog_aci_do(report_sxw.rml_parse):
	aci = {}
	locale.setlocale(locale.LC_ALL, "")
	def __init__(self, cr, uid, name, context):
		super(oplog_aci_do, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
			'get_distinct_aci': self.get_distinct_aci,
			'get_do_by_aci': self.get_do_by_aci,
			'get_total_values': self.get_total_values,
			'formatNumber': self.formatNumber,
		})
	def get_distinct_aci(self, aci_do):
		self.aci = {}
		self.totalvalue = 0
		locale.setlocale(locale.LC_ALL, "")
		for line in aci_do:
			if line.aci_name in self.aci:
				self.aci[line.aci_name].append([line.name, line.referencia, line.concept, line.container, line.motonave, line.port, line.fecha_solicitud, line.total])
			else:
				self.aci[line.aci_name] = [[line.name, line.referencia, line.concept, line.container, line.motonave, line.port, line.fecha_solicitud, line.total]]
		for key, val in self.aci.items():
			sum = 0
			for item in val:
				sum += item[7]
				self.totalvalue += sum
			self.aci[key].append(['','','','','','','',sum])
		return self.aci.keys()

	def get_total_values(self):
		return self.totalvalue
	
	def formatNumber(self, val):
		return locale.format('%d', val, True)

	def get_do_by_aci(self, aci_name):
		#print aci_name
		if aci_name in self.aci:
			#print self.aci[aci_name]
			return self.aci[aci_name]
		else:
			return None

report_sxw.report_sxw('report.oplog.aci.do','oplog.aci.do','addons/oplog/cartas/aci_do.rml',parser=oplog_aci_do, header=False)

class oplog_lista_facturacion_do(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_lista_facturacion_do, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.facturacion','oplog.facturacion','addons/oplog/cartas/facturacion.rml',parser=oplog_lista_facturacion_do, header=False)

class oplog_carta_radicado(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_radicado, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.radicado3','oplog.radicado','addons/oplog/cartas/radicado.rml',parser=oplog_carta_radicado, header=False)

class oplog_carta_vaciado3(report_sxw.rml_parse):
	def __init__(self, cr, uid, name, context):
		super(oplog_carta_vaciado3, self).__init__(cr, uid, name, context)
		self.localcontext.update( {
			'time': time, 
		})

report_sxw.report_sxw('report.oplog.do.vaciado3','oplog.vaciado','addons/oplog/cartas/vaciado.rml',parser=oplog_carta_vaciado3, header=False)
