# -*- coding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2008 Naritas Ltda. (http://www.naritasltda.com) All Rights Reserved.
#
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License 
# Version 3 as published by the Free Software Foundation 
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


import time
import wizard
import osv
import pooler

section_form = '''<?xml version="1.0"?>
<form string="Copiar y pegar DO en el SYGA">
	<field name="doct" string="DOCT"/>
	<field name="Puerto"/>
	<field name="Puerto"/>
	<field name="Puerto"/>
	<separator string="Datos del BLM" colspan="4"/>
	<field name="BLM No."/>
	<field name="Puerto"/>
	<field name="section_id"/>
</form>'''

section_fields = {
	'doct': {'string':'DOCT', 'type':'char', 'required':True, 'size':64},
	'menu_parent_id': {'string':'Parent menu', 'type':'many2one', 'relation':'ir.ui.menu'},
	'section_id': {'string':'Case Section', 'type':'many2one', 'relation':'crm.case.section', 'required':True},
}

def oplog_dian_syga(self, cr, uid, data, context):
	
	# Methods for call data from clasess: oplog.do / oplog.blm / oplog.blh / oplog.contenedor
	#pool = pooler.get_pool(cr.dbname)
	#pool.get('oplog.dian').menu_create(cr, uid, [data['form']['section_id']], data['form']['menu_name'],  data['form']['menu_parent_id'], context)
	#return {}

class wizard_oplog_dian_syga(wizard.interface):
	states = {
		'init': {
			#Call Method
			'actions': [], 
			'result': {'type':'form', 'arch':section_form, 'fields':section_fields, 'state':[('end','Cancel'),('create','Create menu Entries')]}
		},
		'confirm': {
			# probabily call method to confirm copy/pasted data at SYGA Dian System.
			'actions': [],
			'result': {'type':'state', 'state':'end'}
		}
	}
wizard_oplog_dian_syga('oplog.dian')

