﻿# -*- coding: utf-8 -*-

##############################################################################
#
# Copyright (c) 2007-2008 Naritas Ltda. (http://www.naritasltda.com) All Rights Reserved.
#
# $Id$
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License 
# Version 3 as published by the Free Software Foundation 
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import netsvc
from osv import fields, osv

class res_partner(osv.osv):
	_inherit = "res.partner"
	_columns = {
		'aci_dian_code': fields.char('Código DIAN', size=16, help="Código asignado por la DIAN"),
		'code_password': fields.char('Contraseña SYGA', size=16, help="Contraseña de acceso al SYGA"),
	}
res_partner()